[{
    Name: "System Sensor",
    Author: "David Vinet",
    Version: "2015-11-30",

    GroupName: '',
    IconImage: 'pages/control/widgets/homegenie/generic/images/sensor.png',
    StatusText: '',
    Description: '',
    Initialized: false,

    RenderView: function (cuid, module) {
        var container = $(cuid);
        var widget = container.find('[data-ui-field=widget]');
        //
        if (!this.Initialized) {
            this.Initialized = true;
            //
            // ui events handlers
            //
            // settings button
            widget.find('[data-ui-field=settings]').on('click', function () {
                HG.WebApp.Control.EditModule(module);
            });
        }

        widget.find('[data-ui-field=name]').html(module.Name);
        //
        var sensoricon = '';
        var sensorimgdata = '';
        var sensortxtdata = '';
        var infotext = '';
        var lastupdatetime = 0;
      
        if(module.Properties != null) {
           for (p = 0; p < module.Properties.length; p++) {
                if (module.Properties[p].Name.indexOf('System.') == 0 || module.Properties[p].Name == 'Program.UiRefresh') 
                {
                    var value = Math.round(module.Properties[p].Value.replace(',', '.') * 10) / 10;
                    if (isNaN(value)) value = module.Properties[p].Value;
                    //
                    var displayname = '<b>' + module.Properties[p].Name + '</b>';
                    //displayname = displayname.replace('Meter.', '');
                    //displayname = displayname.replace('Status.', '');
                    //displayname = '<b>' + displayname + '</b>';
                    //
                    var displayvalue = value;
                    //
                    var updatetime = module.Properties[p].UpdateTime;
                    if (typeof(updatetime) != 'undefined')
                    {
                        updatetime = updatetime.replace(' ', 'T'); // fix for IE and FF
                        var d = new Date(updatetime);
                        if (lastupdatetime < d) {
                            lastupdatetime = d;
                        }
                    }
                    //
                    var imagesrc = '';
                    //
                    if (module.Properties[p].Name == 'System.CPU') {
                        //imagesrc = 'hg-indicator-temperature';
                        //var temp = module.Properties[p].Value.replace(',', '.');
                        displayvalue = value + '%';
                    }
                    else if (module.Properties[p].Name == 'System.Disk') {
                        //imagesrc = 'hg-indicator-luminance';
                        displayvalue = value + '%';
                    }
                    else if (module.Properties[p].Name == 'System.Memory') {
                        //imagesrc = 'hg-indicator-humidity';
                        displayvalue = value + '%';
                    }
   
                    if (imagesrc != '') {
                        displayname = '<span class="' + imagesrc + '" style="padding-left:0;width:20px;">&nbsp;</span>';
                    	if( displayvalue != '' )
                    	{
				          var template = container.find('[data-ui-field=iconvaluetemplate]').html();		
	 			          template = template.replace('%icon%', displayname);
				          template = template.replace('%value%', displayvalue);
				          sensorimgdata += template;
					    }
	                    else
                    	{
				          var template = container.find('[data-ui-field=icontemplate]').html();
				          template = template.replace('%icon%', displayname);
				          sensoricon += template;
					    }
                    }
                    else {
                    	if( displayvalue != '' )
                    	{
				          var template = container.find('[data-ui-field=valuetemplate]').html();
				          template = template.replace('%label%', displayname);
				          template = template.replace('%value%', displayvalue);
				          sensortxtdata += template;
					    }
                    }
                }
            }
        }
        var widgeticon = HG.WebApp.Utility.GetModulePropertyByName(module, 'Widget.DisplayIcon');
        if (widgeticon != null && widgeticon.Value != '') {
            this.IconImage = widgeticon.Value;
        }
        //
        widget.find('[data-ui-field=description]').html((module.Domain.substring(module.Domain.lastIndexOf('.') + 1))+' '+module.Address);
        //
        if (sensoricon != '') sensoricon = sensoricon + '<br clear="all" />';
        if (sensorimgdata != '') sensorimgdata = sensorimgdata + '<br clear="all" />';
        if (sensortxtdata != '') sensortxtdata = sensortxtdata + '<br clear="all" />';
        if (lastupdatetime > 0) {
            this.UpdateTime = HG.WebApp.Utility.FormatDate(lastupdatetime) + ' ' + HG.WebApp.Utility.FormatDateTime(lastupdatetime);
        widget.find('[data-ui-field=status]').html('<span style="vertical-align:middle;font-size:13px">' + this.UpdateTime + '</span>&nbsp;&nbsp;' + infotext);
        widget.find('[data-ui-field=sensoronoff]').html(sensoricon);
        widget.find('[data-ui-field=sensorstatus]').html(sensorimgdata + sensortxtdata);
        widget.find('[data-ui-field=icon]').attr('src', this.IconImage);
      }
   }

}]